Bug 489220 - RFE: Incremental yum updates for small disks and small transactions
RFE: Incremental yum updates for small disks and small transactions
Status: NEW
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Seth Vidal
Fedora Extras Quality Assurance
: FutureFeature, Reopened, Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-08 15:08 EDT by Christopher Beland
Modified: 2016-04-20 08:57 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-03-11 07:10:07 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Christopher Beland 2009-03-08 15:08:21 EDT
So I installed Fedora 11 Alpha on a 2GB LiveUSB drive using "livecd-iso-to-disk --overlay-size-mb 1024" and the stock ISO.  Due to the mass rebuild, there are over 900MB of updates pending.  By default, /var/cache/yum is a separate filesystem with a maximum capacity of I think 375MB.

In order to get updates to work, you can manually select certain packages to update, and do a number of update cycles. For example, update all packages starting with a, b, d, e, or f for the first round.  These packages are deleted after they are installed, so then you can proceed to "g", and so on.

An alternative is to mount the hard drive and make /var/cache/yum a symlink to a temporary directory there.  I don't recommend this; I tried it and I made my hard drive temporarily unbootable, I think because of an SELinux relabel triggered by one of the updates.  

The alphabetical method is very time consuming; I'd like to be able to ask people reporting bugs against Fedora 9 or 10: "Try reproducing on the latest Rawhide; just download this ISO, run this command, boot off your USB stick, run 'yum update', and try to reproduce".  That's time consuming enough without having to work around LiveUSB disk space limitations.

It would be much more convenient if yum detected the limited disk space, and divided the update list into smaller chunks.  There's no need to do all of the updates all at once, only the updates where there are cross-package dependencies.  yum is already really good at resolving dependencies automatically, and at being a really convenient program to use, so it seems like a natural enhancement.
Comment 1 James Antill 2009-03-09 11:14:31 EDT
 Some time ago now I tried:

http://people.redhat.com/jantill/yum/commands/yum-iter-update.py

...which was my first attempt at this, which mostly does work but needs to be much more intelligent. Long term were looking at putting something inside yum that will split the transaction ... but it's not high on the list.
 Patches accepted :).
Comment 2 Thierry Vignaud 2010-09-24 11:16:27 EDT
Indeed, I was just going to submit a similar bug report.
This feature is availlable in Mandriva's urpmi for years.
It enables to:
- use less disk while installing or upgrading
- prevent a small glitch to prevent the whole installation (such as a %post or %postun failing though there've been improvements in rpm regarding this)
- prevent an "updated repository during the local system update" to make a download failed and thus the whole upgrade failed.
- ...
Comment 3 seth vidal 2010-09-24 11:23:31 EDT
Thierry,
 If you'd like to help work on yum to implement this feature we'll be glad to get some assistance and/or patches for it.

thanks,
-sv
Comment 4 James Antill 2010-10-15 09:03:19 EDT
The beta plugin I did for bug#640918 should also help your case, feel free to try it out and provide feedback.
Comment 5 Valentina Mukhamedzhanova 2014-03-11 07:10:07 EDT
Closing, since we didn't get a reply.
Comment 6 Christopher Beland 2014-09-30 13:20:49 EDT
That plugin doesn't address the original bug report.

Note You need to log in before you can comment on or make changes to this bug.